import { TestBed } from '@angular/core/testing';

import { EnviromentUtilService } from './enviroment-util.service';
import { interval, fromEvent, concat, merge, race, of, zip } from 'rxjs';
import {
  take,
  map,
  combineAll,
  tap,
  mapTo,
  delay,
  switchMap
} from 'rxjs/operators';

describe('EnviromentUtilService', () => {
  beforeEach(() => TestBed.configureTestingModule({}));

  it('should be created', () => {
    const service: EnviromentUtilService = TestBed.get(EnviromentUtilService);
    expect(service).toBeTruthy();
  });

  // it('rxjs combineAll', () => {
  //   const source = interval(1000).pipe(take(2));
  //   const example = source.pipe(
  //     map(sv => {
  //       console.log('sv', sv, new Date());

  //       return interval(1000).pipe(
  //         tap(ev => {
  //           console.log('sv', sv, 'ev', ev, new Date());
  //         }),
  //         map(ev => `Result (${sv}): ${ev}`),
  //         take(3)
  //       );
  //     })
  //   );
  //   const result = example.pipe(combineAll());

  //   result.subscribe(x => console.log('x', x, new Date()));
  // });

  // it('rxjs merge', () => {
  //   // emit every 2.5 seconds
  //   const first = interval(2500);
  //   // emit every 2 seconds
  //   const second = interval(2000);
  //   // emit every 1.5 seconds
  //   const third = interval(1500);
  //   // emit every 1 second
  //   const fourth = interval(1000);

  //   // emit outputs from one observable
  //   const example = merge(
  //     first.pipe(mapTo('FIRST!')),
  //     second.pipe(mapTo('SECOND!')),
  //     third.pipe(mapTo('THIRD')),
  //     fourth.pipe(mapTo('FOURTH'))
  //   );
  //   // output: "FOURTH", "THIRD", "SECOND!", "FOURTH", "FIRST!", "THIRD", "FOURTH"
  //   const subscribe = example.subscribe(val => console.log(val));
  // });

  // it('rxjs race', () => {
  //   // take the first observable to emit
  //   const example = race(
  //     // emit every 1.5s
  //     interval(1500).pipe(mapTo('1.5s won!')),
  //     // emit every 1s
  //     interval(1000).pipe(mapTo('1s won!')),
  //     // emit every 2s
  //     interval(2000).pipe(mapTo('2s won!')),
  //     // emit every 2.5s
  //     interval(2500).pipe(mapTo('2.5s won!'))
  //   );
  //   // output: "1s won!"..."1s won!"...etc
  //   const subscribe = example.subscribe(val => console.log(val));
  // });

  // it('rxjs zip', () => {
  //   const sourceOne = of('Hello');
  //   const sourceTwo = of('World!');
  //   const sourceThree = of('Goodbye');
  //   const sourceFour = of('World!');
  //   // wait until all observables have emitted a value then emit all as an array
  //   const example = zip(
  //     sourceOne,
  //     sourceTwo.pipe(delay(2000)),
  //     sourceThree.pipe(delay(1000)),
  //     sourceFour.pipe(delay(3000))
  //   );
  //   // output: ["Hello", "World!", "Goodbye", "World!"]
  //   const subscribe = example.subscribe(val => console.log(val));
  // });

  it('rxjs zip', () => {
    const switched = of(1, 2, 3).pipe(
      switchMap((x: number) => {
        console.log('x', x);
        return of(x, x ** 2, x ** 3);
      })
    );
    switched.subscribe(x => console.log(x));
  });
});
